# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.807403
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class LeadSource(BaseModel):
    """
    LeadSource
    """ # noqa: E501
    create_time: Optional[StrictStr] = Field(default=None, description="The time that this lead source was created")
    description: Optional[StrictStr] = Field(default=None, description="The description of the lead source")
    end_time: Optional[StrictStr] = Field(default=None, description="The time that this lead source will end")
    id: Optional[StrictStr] = Field(default=None, description="The unique identifier for thia lead source")
    lead_source_category_id: Optional[StrictStr] = Field(default=None, description="The ID of the category that the lead source belongs to")
    medium: Optional[StrictStr] = Field(default=None, description="The medium of the lead source")
    message: Optional[StrictStr] = Field(default=None, description="The message/content of the lead source")
    name: Optional[StrictStr] = Field(default=None, description="The name of the lead source")
    start_time: Optional[StrictStr] = Field(default=None, description="The time that this lead source started")
    status: Optional[StrictStr] = Field(default=None, description="The status of the lead source")
    update_time: Optional[StrictStr] = Field(default=None, description="The time that this lead source was last updated")
    vendor: Optional[StrictStr] = Field(default=None, description="The vendor of the lead source")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["create_time", "description", "end_time", "id", "lead_source_category_id", "medium", "message", "name", "start_time", "status", "update_time", "vendor"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ACTIVE', 'INACTIVE']):
            raise ValueError("must be one of enum values ('ACTIVE', 'INACTIVE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LeadSource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LeadSource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "create_time": obj.get("create_time"),
            "description": obj.get("description"),
            "end_time": obj.get("end_time"),
            "id": obj.get("id"),
            "lead_source_category_id": obj.get("lead_source_category_id"),
            "medium": obj.get("medium"),
            "message": obj.get("message"),
            "name": obj.get("name"),
            "start_time": obj.get("start_time"),
            "status": obj.get("status"),
            "update_time": obj.get("update_time"),
            "vendor": obj.get("vendor")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


